/**
 * postal.federation - A base plugin for federating instances of postal.js across various boundaries.
 * Author: Jim Cowart (http://freshbrewedcode.com/jimcowart)
 * Version: v0.3.0-rc1
 * Url: http://github.com/postaljs/postal.federation
 * License(s): MIT, GPL
 */
(function(n,t){"object"==typeof module&&module.exports?module.exports=function(n){return t(require("lodash"),n,require("riveter"))}:"function"==typeof define&&define.amd?define(["lodash","postal","riveter"],function(e,i,o){return t(e,i,o,n)}):n.postal=t(n._,n.postal,n.riveter,n)})(this,function(n,t,e,i,o){function s(n){t.fedx.signalReady.apply(this,n)}function a(n){t.fedx.send.apply(this,n)}function c(n){t.fedx.onFederatedMsg.call(this,n)}t.createUUID||(t.createUUID=function(){for(var n=[],t="0123456789abcdef",e=0;36>e;e++)n[e]=t.substr(Math.floor(16*Math.random()),1);return n[14]="4",n[19]=t.substr(3&n[19]|8,1),n[8]=n[13]=n[18]=n[23]="-",n.join("")}),t.instanceId||(t.instanceId=function(){var n,e;return function(i){return i&&(e=n,n=i,t.publish({channel:t.configuration.SYSTEM_CHANNEL,topic:"instanceId.changed",data:{oldId:e,newId:n}})),n}}());var r=function(){},d=!1,p=[],l=[],f=[],u={enabled:!0,filterMode:"whitelist",filterDirection:"both"},h=u,g=function(e,i,o){var s=Object.prototype.hasOwnProperty.call(t.fedx.filters[o],e),a=s&&n.any(t.fedx.filters[o][e],function(n){return t.configuration.resolver.compare(n,i)}),c="blacklist"===h.filterMode;return h.enabled&&(c&&(!s||s&&!a)||!c&&s&&a)},k={ping:function(){return{type:"federation.ping",instanceId:t.instanceId(),timeStamp:new Date,ticket:t.createUUID()}},pong:function(n){return{type:"federation.pong",instanceId:t.instanceId(),timeStamp:new Date,pingData:{instanceId:n.instanceId,timeStamp:n.timeStamp,ticket:n.ticket}}},message:function(n){return{type:"federation.message",instanceId:t.instanceId(),timeStamp:new Date,envelope:n}},disconnect:function(){return{type:"federation.disconnect",instanceId:t.instanceId(),timeStamp:new Date}},bundle:function(n){return{type:"federation.bundle",instanceId:t.instanceId(),timeStamp:new Date,packingSlips:n}}},I={"federation.ping":function(n){n.source.setInstanceId(n.packingSlip.instanceId),n.source.handshakeComplete?n.source.sendPong(n.packingSlip):n.source.sendBundle([t.fedx.getPackingSlip("pong",n.packingSlip),t.fedx.getPackingSlip("ping")])},"federation.pong":function(e){e.source.handshakeComplete=!0,e.source.setInstanceId(e.packingSlip.instanceId),e.source.pings[e.packingSlip.pingData.ticket]&&(e.source.pings[e.packingSlip.pingData.ticket].callback({ticket:e.packingSlip.pingData.ticket,instanceId:e.packingSlip.instanceId,source:e.source}),e.source.pings[e.packingSlip.pingData.ticket]=o),n.contains(t.fedx.clients,e.packingSlip.instanceId)||t.fedx.clients.push(e.packingSlip.instanceId),t.publish({channel:"postal.federation",topic:"client.federated",data:{remoteId:e.source.instanceId,localId:t.instanceId(),transport:e.transport}})},"federation.disconnect":function(e){t.fedx.clients=n.without(t.fedx.clients,e.source.instanceId),t.fedx.disconnect({transport:e.source.transportName,instanceId:e.source.instanceId,doNotNotify:!0})},"federation.message":function(n){var e=n.packingSlip.envelope;g(e.channel,e.topic,"in")&&(e.lastSender=n.packingSlip.instanceId,t.publish(e))},"federation.bundle":function(e){n.each(e.packingSlip.packingSlips,function(i){t.fedx.onFederatedMsg(n.extend({},e,{packingSlip:i}))})}},S=function(n,t,e){this.target=n,this.options=t||{},this.pings={},this.instanceId=e,this.handshakeComplete=!1};return S.prototype.sendPing=function(n){var e=t.fedx.getPackingSlip("ping");this.pings[e.ticket]={ticket:e.ticket,callback:n||r},this.send(e)},S.prototype.sendPong=function(n){this.send(t.fedx.getPackingSlip("pong",n))},S.prototype.sendBundle=function(n){this.send(t.fedx.getPackingSlip("bundle",n))},S.prototype.sendMessage=function(e){if(this.handshakeComplete){e.originId=e.originId||t.instanceId();var i=n.clone(e);!this.instanceId||this.instanceId===i.lastSender||i.knownIds&&i.knownIds.length&&(!i.knownIds||n.include(i.knownIds,this.instanceId))||(i.knownIds=(i.knownIds||[]).concat(n.without(t.fedx.clients,this.instanceId)),this.send(t.fedx.getPackingSlip("message",i)))}},S.prototype.disconnect=function(){this.send(t.fedx.getPackingSlip("disconnect"))},S.prototype.onMessage=function(n){this.shouldProcess()&&t.fedx.onFederatedMsg({transport:this.transportName,packingSlip:n,source:this})},S.prototype.shouldProcess=function(){return!0},S.prototype.send=function(){throw new Error("An object deriving from FederationClient must provide an implementation for 'send'.")},S.prototype.setInstanceId=function(n){this.instanceId=n},e(S),t.fedx=n.extend({FederationClient:S,packingSlips:k,handlers:I,clients:[],transports:{},filters:{"in":{},out:{}},addFilter:function(t){t=n.isArray(t)?t:[t],n.each(t,function(t){t.direction=t.direction||h.filterDirection,n.each("both"===t.direction?["in","out"]:[t.direction],function(e){this.filters[e][t.channel]?n.include(this.filters[e][t.channel],t.topic)||this.filters[e][t.channel].push(t.topic):this.filters[e][t.channel]=[t.topic]},this)},this)},removeFilter:function(t){t=n.isArray(t)?t:[t],n.each(t,function(t){t.direction=t.direction||h.filterDirection,n.each("both"===t.direction?["in","out"]:[t.direction],function(e){this.filters[e][t.channel]&&n.include(this.filters[e][t.channel],t.topic)&&(this.filters[e][t.channel]=n.without(this.filters[e][t.channel],t.topic))},this)},this)},canSendRemote:function(n,t){return g(n,t,"out")},configure:function(t){if(t&&t.filterMode&&"blacklist"!==t.filterMode&&"whitelist"!==t.filterMode)throw new Error("postal.fedx filterMode must be 'blacklist' or 'whitelist'.");return t&&(h=n.defaults(t,u)),h},getPackingSlip:function(n){return Object.prototype.hasOwnProperty.call(k,n)?k[n].apply(this,Array.prototype.slice.call(arguments,1)):void 0},onFederatedMsg:function(n){if(!d)return void p.push(n);if(!Object.prototype.hasOwnProperty.call(I,n.packingSlip.type))throw new Error("postal.federation does not have a message handler for '"+n.packingSlip.type+"'.");I[n.packingSlip.type](n)},sendMessage:function(t){return d?void n.each(this.transports,function(n){n.sendMessage(t)}):void l.push(arguments)},disconnect:function(t){t=t||{};var e=this.transports;t.transport&&(e={},e[t.transport]=this.transports[t.transport]),n.each(e,function(n){n.disconnect({target:t.target,instanceId:t.instanceId,doNotNotify:!!t.doNotNotify})},this)},_getTransports:function(){return n.reduce(this.transports,function(n,t,e){return n[e]=!0,n},{})},signalReady:function(t,e,i){if(!d)return void f.push(arguments);var o=this._getTransports();switch(arguments.length){case 1:"function"==typeof t?i=t:"string"==typeof t&&(o={},o[t]=this.transports[t],i=r);break;case 2:"string"==typeof t?(o={},o[t]=this.transports[t]):o=t,i=e||r;break;case 3:o={},o[t]=[e]}n.each(o,function(n,t){n="boolean"==typeof n?[]:n,this.transports[t].signalReady(n,i)},this)}},t.fedx),t.addWireTap(function(n,e){t.fedx.canSendRemote(e.channel,e.topic)&&t.fedx.sendMessage(e)}),t.subscribe({channel:t.configuration.SYSTEM_CHANNEL,topic:"instanceId.changed",callback:function(){for(d=!0;f.length;)s(f.shift());for(;l.length;)a(l.shift());for(;p.length;)c(p.shift())}}),t.instanceId()!==o&&(d=!0),t});